##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (ksm-sntp)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for KSM-Sntp

%define name		ksm-sntp
%define version		0.0.3
%define release		2.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	ksm-sntp is an alternative for an NTP daemon
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		System/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-sntppkg,ksm-sntpcapab
Requires:	ntp
Requires:	ksm-lib-sh >= 3.0.2-1.1.0
#Provides:	ksm-sntpd
#Conflicts:	ksm-sntpd-other,libksm-sntp == 0.0.0
#Obsoletes:	myksm-sntpd

%description
This package contains KSM-Sntp. This is an alternative for a fully featured 
NTP daemon. It runs sntp at system startup and sets the system time.

Please check/configure:
 /etc/sysconfig/ksm-sntp

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/ksm-sntp.conf
#%config %{_confdir}/ksm-sntp.conf
#%config %{_scnfdir}/ksm-sntp
#%attr(644,root,root)%{_confdir}/ksm-sntp.conf
%attr(644,root,root)%{_scnfdir}/ksm-sntp

#%attr(777,root,root)%{_bindir}/rcksm-sntp
#%attr(777,root,root)%{_bindir}/rcksm-sntpd

%attr(700,root,root)%{_sbindir}/runksm-sntp

%{_datadir}/RELEASE
%{_datadir}/VERSION
%attr(744,root,root)%{_datadir}/ksm-sntp.rc
%{_datadir}/ksm-sntp.service

#/usr/share/applications/ksm-sntp.desktop
#%{_icondir}/16x16/apps/ksm-sntp.png
#%{_icondir}/22x22/apps/ksm-sntp.png
#%{_icondir}/32x32/apps/ksm-sntp.png
#%{_icondir}/48x48/apps/ksm-sntp.png
#%{_icondir}/64x64/apps/ksm-sntp.png
#%{_icondir}/128x128/apps/ksm-sntp.png
#/usr/share/pixmaps/ksm-sntp.png

#%docdir %{_man1dir}
#%{_man1dir}/ksm-sntp.1.gz

%docdir %{_man8dir}
%{_man8dir}/runksm-sntp.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
#test -e %{_confdir}/ksm-sntp.conf && cp %{_confdir}/ksm-sntp.conf %{_confdir}/ksm-sntp.conf.rpmsave
test -e %{_scnfdir}/ksm-sntp && cp %{_scnfdir}/ksm-sntp %{_scnfdir}/ksm-sntp.rpmsave

# disable sampledm
#test -x %{_bindir}/togglesntp && %{_bindir}/togglesntp -d -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/ksm-sntp.directory \
#	/usr/share/applications/ksm-sntp.desktop \
#	/usr/share/applications/ksm-sntp-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-SNTP
if [ -d %{_sysddir} ]; then				# systemd
	if [ -e %{_sysddir}/ksm-sntp.service ]; then
		systemctl stop ksm-sntp.service
		systemctl disable ksm-sntp.service
		rm %{_sysddir}/ksm-sntp.service
		systemctl daemon-reload
	fi
else							# SysV init
	test -x %{_rcdir}/ksm-sntp && %{_rcdir}/ksm-sntp stop > /dev/null 2>&1
	insserv -r ksm-sntp
	rm -f %{_rcdir}/ksm-sntp
	rm -f %{_bindir}/rcksm-sntp
fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
cf=%{_scnfdir}/ksm-sntp
cnfvars='NTP_SERVER'

c='' s='' t='' cnt=0 i=0 ret=0

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/ksm-sntp.directory \
#	/usr/share/applications/ksm-sntp.desktop \
#	/usr/share/applications/ksm-sntp-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - install ksm-sntp
if [ -d %{_sysddir} ]; then				# systemd
	cp --preserve=mode %{_datadir}/ksm-sntp.service %{_sysddir}/
	systemctl daemon-reload
	systemctl enable ksm-sntp.service

	echo "The unit is already added to the bootprocess."
#	echo "Next configure the $cf"
#	echo "If wanted start it within yast or manual with:"
#	echo "runksm-sntp --start"
else							# SysV init
	cp --preserve=mode %{_datadir}/ksm-sntp.rc %{_rcdir}/ksm-sntp
	ln -sf %{_rcdir}/ksm-sntp %{_bindir}/rcksm-sntp
	insserv ksm-sntp

	echo "The script is already added to the bootprocess."
#	echo "Next configure the $cf"
#	echo "If wanted start it within yast or manual with:"
#	echo "rcksm-sntp start"
fi

if [ "$1" == 1 ]; then					# install package
	echo "Configure $cf"
	#echo "Users must create HOME/.ksm-sntprc with update-ksm-sntp"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi

#		# update array vars MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				# array MainArr
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.ksm-sntprc with update-ksm-sntp"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/ksm-sntp.conf && cp %{_confdir}/ksm-sntp.conf %{_confdir}/ksm-sntp.conf.rpmsave
	test -e %{_scnfdir}/ksm-sntp && cp %{_scnfdir}/ksm-sntp %{_scnfdir}/ksm-sntp.rpmsave

	# disable ksm-sntp
	#test -x %{_bindir}/togglesntp && %{_bindir}/togglesntp -d -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/ksm-sntp.directory \
	#	/usr/share/applications/ksm-sntp.desktop \
	#	/usr/share/applications/ksm-sntp-admin.desktop

	# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-SNTP
	if [ -d %{_sysddir} ]; then				# systemd
		if [ -e %{_sysddir}/ksm-sntp.service ]; then
			systemctl stop ksm-sntp.service
			systemctl disable ksm-sntp.service
			rm %{_sysddir}/ksm-sntp.service
			systemctl daemon-reload
		fi
	else							# SysV init
		test -x %{_rcdir}/ksm-sntp && %{_rcdir}/ksm-sntp stop > /dev/null 2>&1
		insserv -r ksm-sntp
		rm -f %{_rcdir}/ksm-sntp
		rm -f %{_bindir}/rcksm-sntp
	fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-sntpdir
#else							# upgrade package
fi
exit 0

%changelog
* Sat Dec 10 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-2.0.0
- ksm-sntp.service has been revised/improved.

* Tue Oct 03 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.2.0
- 'runksm-sntp' has been revised/improved.
- ksm-sntp.service has been revised.

* Wed Sep 27 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.1.0
- 'runksm-sntp' has been revised.

* Wed Sep 20 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.0.0
- Now we have systemd support.
  The package installs different on a
  SystemV init system or on a systemd system.

* Mon Nov 28 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- Config name has changed from sntp to ksm-sntp.

* Fri Nov 25 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.1.0
- Corrected missing requirements for RPM.

* Wed Nov 23 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised.

* Wed Nov 23 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  ksm-sntp:	Use sntp at system startup
